stages:
  - build
  - test
  - release

# Define variables
variables:
  # 1) Name of directory where restore and build objects are stored.
  OBJECTS_DIRECTORY: 'obj'
  # 2) Name of directory used for keeping restored dependencies.
  NUGET_PACKAGES_DIRECTORY: '.nuget'
  # 3) A relative path to the source code from project repository root.
  # NOTE: Please edit this path so it matches the structure of your project!
  SOURCE_CODE_PATH: '*/*/'

build:
  stage: build
  image: mcr.microsoft.com/dotnet/sdk:8.0
  script:
    - 'dotnet restore --packages $NUGET_PACKAGES_DIRECTORY'
    - 'dotnet build --no-restore'

test:
  stage: test
  image: mcr.microsoft.com/dotnet/sdk:8.0
  script:
    - 'dotnet restore --packages $NUGET_PACKAGES_DIRECTORY'
    - 'dotnet test --no-restore'

release:
  stage: release
  image: docker:latest
  services:
    - docker:dind
  variables:
    DOCKER_HOST: tcp://docker:2375
  script:
    - 'docker build -t $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME .'
    - 'docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY'
    - 'docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME'
  only:
    - main
    - develop